## coolreader-3.2.59-8.src.tar.gz

=== cr3gui/CMakeLists.txt ===
if (NOT DEFINED DEVICE_NAME)
  if ( ${GUI} STREQUAL CRGUI_XCB )
    SET(DEVICE_NAME all)
  else ()
    SET(DEVICE_NAME v3)
  endif ( ${GUI} STREQUAL CRGUI_XCB )
  message("Device type is not specified! It's necessary to know device type in order to choose proper keyboard layout, etc...")
  message("Using ${DEVICE_NAME} as default")
  message("Add cmake parameter -D DEVICE_NAME={v3|v5|n516|v3a} to use another device settings")
else ()
  message("Device type is set to ${DEVICE_NAME}")
endif (NOT DEFINED DEVICE_NAME)


#FIND_PACKAGE(Gettext REQUIRED)

#use macros from kwwidgets instead of usual
SET(KWWidgets_CMAKE_DIR ${CMAKE_SOURCE_DIR}/tools/)
INCLUDE(${KWWidgets_CMAKE_DIR}FindGettext.cmake)
INCLUDE(${KWWidgets_CMAKE_DIR}KWWidgetsInternationalizationMacros.cmake)

SET (LANGUAGES ru uk de fr bg es ca cs pl lt zh_CN zh_TW)
message( "Languages: ${LANGUAGES}" )

SET (CR3_SOURCES 
  src/bgfit.cpp
  src/citedlg.cpp 
  src/fsmenu.cpp    
  src/mainwnd.cpp  
  src/recentdlg.cpp 
  src/selnavig.cpp 
  src/tocdlg.cpp 
  src/bmkdlg.cpp   
  src/cr3_def_cover.cpp 
  src/cr3main.cpp  
  src/dictdlg.cpp 
  src/linksdlg.cpp 
  src/numedit.cpp 
  src/scrkbd.cpp   
  src/settings.cpp 
  src/viewdlg.cpp
)

SET (CR3_STYLES
  data/epub.css  data/fb2.css  data/htm.css  data/rtf.css  data/txt.css data/chm.css
)

if (${GUI} STREQUAL CRGUI_PB)
    SET(CR3_SOURCES ${CR3_SOURCES} src/cr3pocketbook.cpp)
endif (${GUI} STREQUAL CRGUI_PB)

#   
KWWidgets_CREATE_GETTEXT_TARGETS(
   DOMAIN_NAME "cr3"
   LOCALE_LIST "${LANGUAGES}"
   SOURCES "${CR3_SOURCES}"
   PO_DIR ${CMAKE_CURRENT_SOURCE_DIR}/po
   CREATE_POT_TARGET 1
   CREATE_PO_TARGET 1
   MO_BUILD_DIR ${CMAKE_BINARY_DIR}${CMAKE_DATA_DIR}/i18n
   ADD_MO_TARGET_TO_ALL 1
)
#   CREATE_PO_TARGET
#   CREATE_MO_TARGET

SET (CR3_BIN_DESTINATION bin)

if ( ${GUI} STREQUAL CRGUI_XCB )

    ADD_DEFINITIONS( -DUSE_FONTCONFIG=1 )
    SET(CR3_SOURCES ${CR3_SOURCES} src/cr3xcb.cpp)
    SET (EXTRA_LIBS xcb xcb-aux xcb-atom xcb-image xcb-keysyms xcb-randr fontconfig )

    INSTALL( FILES ${CR3_STYLES} DESTINATION share/cr3)
    INSTALL( FILES data/desktop/cr3.desktop DESTINATION share/applications)
    INSTALL( DIRECTORY data/hyph/ DESTINATION share/cr3/hyph
      FILES_MATCHING PATTERN "*.pdb" )
    INSTALL( DIRECTORY data/hyph/ DESTINATION share/cr3/hyph
      FILES_MATCHING PATTERN "*.pattern" )
    IF (${DEVICE_NAME} STREQUAL all)
        INSTALL( DIRECTORY data/devices/v3/skins DESTINATION share/cr3/v3 )
        INSTALL( DIRECTORY data/devices/n516/skins DESTINATION share/cr3/n516 )
        INSTALL( DIRECTORY data/devices/v3/keymaps/ DESTINATION share/cr3/v3 )
        INSTALL( DIRECTORY data/devices/n516/keymaps/ DESTINATION share/cr3/n516 )
    ELSE()
        INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/skins DESTINATION share/cr3 )
        INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/keymaps DESTINATION share/cr3 )
    ENDIF(${DEVICE_NAME} STREQUAL all)
    INSTALL( DIRECTORY data/manual/ DESTINATION share/cr3/manual )
    INSTALL( DIRECTORY ${CMAKE_BINARY_DIR}${CMAKE_DATA_DIR}/i18n/ DESTINATION share/locale
      FILES_MATCHING PATTERN "*.mo" )

elseif ( ${GUI} STREQUAL CRGUI_QT )

    FIND_PACKAGE( Qt4 REQUIRED )
    INCLUDE(${QT_USE_FILE})
    
    SET(CR3_SOURCES ${CR3_SOURCES} src/cr3qt.cpp)
    SET (EXTRA_LIBS ${QT_LIBRARIES} ${STD_LIBS} )
    SET(CR3_STYLES ${CR3_STYLES} data/fb3.css)

    INSTALL( FILES ${CR3_STYLES} DESTINATION root/crengine)
    INSTALL( DIRECTORY data/hyph/ DESTINATION root/crengine/hyph
      FILES_MATCHING PATTERN "*.pdb" )
    INSTALL( DIRECTORY data/hyph/ DESTINATION root/crengine/hyph
      FILES_MATCHING PATTERN "*.pattern" )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/skins/default/ DESTINATION root/crengine/skin )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/keymaps/ DESTINATION root/crengine )
    INSTALL( DIRECTORY data/manual/ DESTINATION root/crengine/manual )

    FOREACH(LANGUAGE ${LANGUAGES})
        SET(MO_FILE "${CMAKE_BINARY_DIR}/i18n/${LANGUAGE}/LC_MESSAGES/cr3.mo")
        INSTALL(FILES ${MO_FILE} DESTINATION root/crengine/i18n RENAME ${LANGUAGE}.mo)
    ENDFOREACH(LANGUAGE ${LANGUAGES})

elseif ( ${GUI} STREQUAL CRGUI_NANOX )

    SET(CR3_SOURCES ${CR3_SOURCES} src/cr3nanox.cpp)
    SET (EXTRA_LIBS nano-X pthread ${DBUS_LIBRARIES} )
    if (ENABLE_DBUS_VIEWER_EVENTS)
        SET (EXTRA_LIBS ${EXTRA_LIBS} ${DBUS_LIBRARIES} )
    endif(ENABLE_DBUS_VIEWER_EVENTS)

    INSTALL( FILES ${CR3_STYLES} DESTINATION root/crengine)
    INSTALL( DIRECTORY data/hyph/ DESTINATION root/crengine/hyph
      FILES_MATCHING PATTERN "*.pdb" )
    INSTALL( DIRECTORY data/hyph/ DESTINATION root/crengine/hyph
      FILES_MATCHING PATTERN "*.pattern" )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/skins/default/ DESTINATION root/crengine/skin )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/keymaps/ DESTINATION root/crengine )
    INSTALL( DIRECTORY data/manual/ DESTINATION root/crengine/manual )

    FOREACH(LANGUAGE ${LANGUAGES})
        SET(MO_FILE "${CMAKE_BINARY_DIR}/i18n/${LANGUAGE}/LC_MESSAGES/cr3.mo")
        INSTALL(FILES ${MO_FILE} DESTINATION root/crengine/i18n RENAME ${LANGUAGE}.mo)
    ENDFOREACH(LANGUAGE ${LANGUAGES})

#    INSTALL( DIRECTORY ${CMAKE_BINARY_DIR}/cr3gui/po/ DESTINATION root/crengine/i18n
#      FILES_MATCHING PATTERN "*.mo" )
    SET (CR3_BIN_DESTINATION root)

elseif ( ${GUI} STREQUAL CRGUI_JINKE_PLUGIN )

    SET(CR3_SOURCES ${CR3_SOURCES} src/cr3jinke.cpp)

    INSTALL( FILES ${CR3_STYLES} DESTINATION root/crengine)
    INSTALL( DIRECTORY data/hyph/ DESTINATION root/crengine/hyph
      FILES_MATCHING PATTERN "*.pdb" )
    INSTALL( DIRECTORY data/hyph/ DESTINATION root/crengine/hyph
      FILES_MATCHING PATTERN "*.pattern" )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/skins/default/ DESTINATION root/crengine/skin )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/keymaps/ DESTINATION root/crengine )
    INSTALL( DIRECTORY data/manual/ DESTINATION root/crengine/manual )

    FOREACH(LANGUAGE ${LANGUAGES})
        SET(MO_FILE "${CMAKE_BINARY_DIR}/i18n/${LANGUAGE}/LC_MESSAGES/cr3.mo")
        INSTALL(FILES ${MO_FILE} DESTINATION root/crengine/i18n RENAME ${LANGUAGE}.mo)
#        INSTALL(FILES ${MO_FILE} DESTINATION root/crengine/i18n RENAME cr3_${LANGUAGE}.mo)
    ENDFOREACH(LANGUAGE ${LANGUAGES})

#    INSTALL( DIRECTORY ${CMAKE_BINARY_DIR}/cr3gui/po/ DESTINATION root/crengine/i18n
#      FILES_MATCHING PATTERN "*.mo" )
    SET (CR3_BIN_DESTINATION usr/lib)

elseif ( ${GUI} STREQUAL CRGUI_WIN32 )

    SET(CR3_SOURCES ${CR3_SOURCES} src/cr3win.cpp)

    INSTALL( FILES ${CR3_STYLES} DESTINATION crengine)
    INSTALL( DIRECTORY data/hyph/ DESTINATION crengine/hyph
      FILES_MATCHING PATTERN "*.pdb" )
    INSTALL( DIRECTORY data/hyph/ DESTINATION crengine/hyph
      FILES_MATCHING PATTERN "*.pattern" )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/skins/default/ DESTINATION crengine/skin )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/keymaps/ DESTINATION crengine )
    INSTALL( DIRECTORY data/manual/ DESTINATION crengine/manual )
    INSTALL( DIRECTORY ${CMAKE_BINARY_DIR}/cr3gui/po/ DESTINATION cr3/i18n
      FILES_MATCHING PATTERN "*.mo" )
    SET (CR3_BIN_DESTINATION .)

elseif (${GUI} STREQUAL CRGUI_PB)
#    SET(CR3_SOURCES ${CR3_SOURCES} src/cr3pocketbook.cpp)
    FIND_LIBRARY(INKVIEW_LIB inkview)
    IF (INKVIEW_LIB)
	IF (DEFINED POCKETBOOK_EMU_GTK)
	    FIND_PACKAGE (GTK2 REQUIRED)
	    FIND_PACKAGE (CURL REQUIRED)
	ENDIF (DEFINED POCKETBOOK_EMU_GTK)
	SET (EXTRA_LIBS ${INKVIEW_LIB} ${GTK2_LIBRARIES} ${CURL_LIBRARIES})
    ELSE (INKVIEW_LIB)
	  message("libinkview library not found!")
    ENDIF (INKVIEW_LIB)

    INSTALL( FILES ${CR3_STYLES} DESTINATION system/share/cr3)
    INSTALL( DIRECTORY data/hyph/ DESTINATION system/share/cr3/hyph
      FILES_MATCHING PATTERN "*.pdb" )
    INSTALL( DIRECTORY data/hyph/ DESTINATION system/share/cr3/hyph
      FILES_MATCHING PATTERN "*.pattern" )
    INSTALL( DIRECTORY data/hyph/ DESTINATION system/share/cr3/hyph
      FILES_MATCHING PATTERN "*.json" )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/skins/default/ DESTINATION system/share/cr3/skin )
    INSTALL( DIRECTORY data/devices/${DEVICE_NAME}/keymaps/ DESTINATION system/share/cr3/keymaps )
    INSTALL( DIRECTORY data/manual/ DESTINATION system/share/cr3/manual )

    FOREACH(LANGUAGE ${LANGUAGES})
        SET(MO_FILE "${CMAKE_BINARY_DIR}/i18n/${LANGUAGE}/LC_MESSAGES/cr3.mo")
        INSTALL(FILES ${MO_FILE} DESTINATION system/share/cr3/i18n RENAME ${LANGUAGE}.mo)
    ENDFOREACH(LANGUAGE ${LANGUAGES})

endif ( ${GUI} STREQUAL CRGUI_XCB )


if ( ${GUI} STREQUAL CRGUI_JINKE_PLUGIN )
    ADD_LIBRARY(fb2 SHARED ${CR3_SOURCES})
    TARGET_LINK_LIBRARIES(fb2 crengine tinydict ${EXTRA_LIBS} ${STD_LIBS})
    if (DEFINED CMAKE_STRIP)
       MESSAGE("Strip command: ${CMAKE_STRIP} ${CMAKE_BINARY_DIR}/cr3gui/libfb2.so" )
       EXECUTE_PROCESS( COMMAND ${CMAKE_STRIP} ${CMAKE_BINARY_DIR}/cr3gui/libfb2.so )
    endif (DEFINED CMAKE_STRIP)
    INSTALL( TARGETS fb2 LIBRARY DESTINATION ${CR3_BIN_DESTINATION} )
elseif (${GUI} STREQUAL CRGUI_PB)
    ADD_EXECUTABLE(cr3-pb.app ${CR3_SOURCES})
    TARGET_LINK_LIBRARIES(cr3-pb.app crengine tinydict ${EXTRA_LIBS} ${STD_LIBS})
    if (DEFINED CMAKE_STRIP)
       MESSAGE("Strip command:  ${CMAKE_STRIP} ${CMAKE_BINARY_DIR}/cr3gui/cr3-pb.app" )
       EXECUTE_PROCESS( COMMAND ${CMAKE_STRIP} ${CMAKE_BINARY_DIR}/cr3gui/cr3-pb.app )
    endif (DEFINED CMAKE_STRIP)
    INSTALL( TARGETS cr3-pb.app RUNTIME DESTINATION ${CR3_BIN_DESTINATION} )
else()
    ADD_EXECUTABLE(cr3 ${CR3_SOURCES})
    TARGET_LINK_LIBRARIES(cr3 crengine tinydict ${EXTRA_LIBS} ${STD_LIBS})
    if (DEFINED CMAKE_STRIP)
       MESSAGE("Strip command:  ${CMAKE_STRIP} ${CMAKE_BINARY_DIR}/cr3gui/cr3" )
       EXECUTE_PROCESS( COMMAND ${CMAKE_STRIP} ${CMAKE_BINARY_DIR}/cr3gui/cr3 )
    endif (DEFINED CMAKE_STRIP)
    INSTALL( TARGETS cr3 RUNTIME DESTINATION ${CR3_BIN_DESTINATION} )
endif ( ${GUI} STREQUAL CRGUI_JINKE_PLUGIN )

if (${GUI} STREQUAL CRGUI_XCB)
    SET(LOGOCNV_SOURCES src/logoconv.cpp)
    ADD_EXECUTABLE(logocnv ${LOGOCNV_SOURCES})
    TARGET_LINK_LIBRARIES(logocnv crengine ${STD_LIBS} ${EXTRA_LIBS})
endif (${GUI} STREQUAL CRGUI_XCB)

=== crengine/CMakeLists.txt ===

option(BUILD_TOOLS "Build tools" OFF)

SET (CRENGINE_SOURCES
    src/cp_stats.cpp
    src/lvstring.cpp
    src/lvstring8collection.cpp
    src/lvstring32collection.cpp
    src/lvstring32hashedcollection.cpp
    src/serialbuf.cpp
    src/crlog.cpp
    src/props.cpp
    src/lstridmap.cpp
    src/rtfimp.cpp
    src/cri18n.cpp
    src/lvmemman.cpp
    src/lvstyles.cpp
    src/crtxtenc.cpp
    src/lvtinydom.cpp
    src/lvstsheet.cpp
    src/txtselector.cpp
    #src/xutils.cpp
    src/crtest.cpp
    src/textlang.cpp
    src/lvstream/lvdefstreambuffer.cpp
    src/lvstream/lvfilemappedstream.cpp
    src/lvstream/lvnamedstream.cpp
    src/lvstream/lvfilestream.cpp
    src/lvstream/lvdirectorycontainer.cpp
    src/lvstream/lvcachedstream.cpp
    src/lvstream/lvzipdecodestream.cpp
    src/lvstream/lvziparc.cpp
    src/lvstream/lvrararc.cpp
    src/lvstream/lvmemorystream.cpp
    src/lvstream/lvtcrstream.cpp
    src/lvstream/lvblockwritestream.cpp
    src/lvstream/lvstream.cpp
    src/lvstream/lvbase64stream.cpp
    src/lvstream/lvstreamutils.cpp
    src/lvxml/lvfileparserbase.cpp
    src/lvxml/lvtextfilebase.cpp
    src/lvxml/lvtextparser.cpp
    src/lvxml/lvtextlinequeue.cpp
    src/lvxml/pmltextimport.cpp
    src/lvxml/lvtextrobustparser.cpp
    src/lvxml/lvtextbookmarkparser.cpp
    src/lvxml/lvxmlparser.cpp
    src/lvxml/lvhtmlparser.cpp
    src/lvxml/fb2coverpageparsercallback.cpp
    src/lvxml/lvxmlutils.cpp
    src/locale_data/fc-lang-data.c
    src/locale_data/crlocaledata.cpp
)

if ( NOT ${GUI} STREQUAL FB2PROPS )
    SET (CRENGINE_SOURCES ${CRENGINE_SOURCES}
        src/lvbmpbuf.cpp   
        src/hyphman.cpp  
        src/crgui.cpp     
        src/crskin.cpp    
        src/lvdocview.cpp  
        src/lvpagesplitter.cpp  
        src/lvtextfm.cpp
        src/lvrend.cpp
        src/wolutil.cpp
        src/hist.cpp      
        src/chmfmt.cpp     
        src/epubfmt.cpp     
        src/pdbfmt.cpp     
        src/wordfmt.cpp
        src/lvopc.cpp
        src/docxfmt.cpp
        src/fb3fmt.cpp
        src/odtfmt.cpp
        src/odxutil.cpp
        src/crconcurrent.cpp
        src/mathml.cpp
        src/lvimg/lvcacheableobject.cpp
        src/lvimg/lvimagesource.cpp
        src/lvimg/crninepatchdecoder.cpp
        src/lvimg/lvjpegimagesource.cpp
        src/lvimg/lvpngimagesource.cpp
        src/lvimg/lvxpmimagesource.cpp
        src/lvimg/lvgifimagesource.cpp
        src/lvimg/lvgifframe.cpp
        src/lvimg/clzwdecoder.cpp
        src/lvimg/lvsvgimagesource.cpp
        src/lvimg/lvstretchimgsource.cpp
        src/lvimg/lvcolortransformimgsource.cpp
        src/lvimg/lvalphatransformimgsource.cpp
        src/lvimg/lvunpackedimgsource.cpp
        src/lvimg/lvdrawbufimgsource.cpp
        src/lvimg/lvimg.cpp
        src/lvfont/lvfont.cpp
        src/lvfont/lvfntman.cpp
        src/lvfont/lvfnt.cpp
        src/lvfont/lvembeddedfont.cpp
        src/lvfont/lvbasefont.cpp
        src/lvfont/lvbitmapfont.cpp
        src/lvfont/lvbitmapfontman.cpp
        src/lvfont/lvfontglyphcache.cpp
        src/lvfont/lvfontcache.cpp
        src/lvfont/lvfontboldtransform.cpp
        src/lvfont/lvfontdef.cpp
        src/lvfont/lvwin32font.cpp
        src/lvfont/lvwin32fontman.cpp
        src/lvfont/lvfreetypeface.cpp
        src/lvfont/lvfreetypefontman.cpp
        src/lvdrawbuf/lvbasedrawbuf.cpp
        src/lvdrawbuf/lvgraydrawbuf.cpp
        src/lvdrawbuf/lvcolordrawbuf.cpp
        src/lvdrawbuf/lvinkmeasurementdrawbuf.cpp
        src/lvdrawbuf/lvimagescaleddrawcallback.cpp
        src/lvdrawbuf/lvdrawbuf_utils.cpp
        #src/xutils.cpp
    )
endif (NOT ${GUI} STREQUAL FB2PROPS)

ADD_LIBRARY(crengine STATIC ${CRENGINE_SOURCES})

if(BUILD_TOOLS)
    add_subdirectory(Tools)
endif(BUILD_TOOLS)

=== tinydict/CMakeLists.txt ===
SET (TINYDICT_SOURCES
    tinydict.cpp
)
ADD_LIBRARY(tinydict STATIC ${TINYDICT_SOURCES})

=== android/app/CMakeLists.txt ===
# For more information about using CMake with Android Studio, read the
# documentation: https://d.android.com/studio/projects/add-native-code.html

# Sets the minimum version of CMake required to build the native library.

cmake_minimum_required(VERSION 3.4.1)

project(cr3engine)

set(CR3_ROOT ${PROJECT_SOURCE_DIR}/../..)

# thirdparty sources definitions
include(${CR3_ROOT}/thirdparty_repo/repo_srcdirs.cmake)

include_directories(${CR3_ROOT}/crengine/include)
include_directories(${CR3_ROOT}/thirdparty/${REPO_LIBPNG_SRCDIR})
include_directories(thirdparty_libs/libpng/lib)
include_directories(${CR3_ROOT}/thirdparty/${REPO_FREETYPE_SRCDIR})
include_directories(${CR3_ROOT}/thirdparty/${REPO_FREETYPE_SRCDIR}/include)
include_directories(thirdparty_libs/freetype)
include_directories(${CR3_ROOT}/thirdparty/${REPO_HARFBUZZ_SRCDIR}/src)
include_directories(${CR3_ROOT}/thirdparty/${REPO_LIBJPEG_SRCDIR})
include_directories(${CR3_ROOT}/thirdparty_unman/antiword)
include_directories(${CR3_ROOT}/thirdparty_unman/chmlib/src)
include_directories(${CR3_ROOT}/thirdparty_unman/nanosvg/src)
include_directories(${CR3_ROOT}/thirdparty/${REPO_FRIBIDI_SRCDIR}/lib)
include_directories(thirdparty_libs/fribidi/lib)
include_directories(${CR3_ROOT}/thirdparty/${REPO_LIBUNIBREAK_SRCDIR}/src)
include_directories(${CR3_ROOT}/thirdparty/${REPO_ZSTD_SRCDIR}/lib)
include_directories(${CR3_ROOT}/thirdparty/${REPO_UTF8PROC_SRCDIR})

add_definitions(-DLINUX=1 -D_LINUX=1)
add_definitions(-DFT_CONFIG_MODULES_H=<android/config/ftmodule.h> -DFT_CONFIG_OPTIONS_H=<android/config/ftoption.h>)
add_definitions(-DDOC_DATA_COMPRESSION_LEVEL=1 -DDOC_BUFFER_SIZE=0x1000000)
add_definitions(-DENABLE_CACHE_FILE_CONTENTS_VALIDATION=1)
add_definitions(-DLDOM_USE_OWN_MEM_MAN=0)
add_definitions(-DCR3_ANTIWORD_PATCH=1 -DENABLE_ANTIWORD=1)
add_definitions(-DLVLONG_FILE_SUPPORT=1)
add_definitions(-DMAX_IMAGE_SCALE_MUL=2)
add_definitions(-DUSE_NANOSVG=1)
add_definitions(-DBUNDLED_FRIBIDI=1)
add_definitions(-DKO_LIBUNIBREAK_PATCH=1)       # libunibreak patched with "add_lb_get_char_class.patch" file from koreader
add_definitions(-DUSE_UTF8PROC=1)

#set(LOCAL_CFLAGS "-Wno-psabi -Wno-unused-variable -Wno-sign-compare -Wno-write-strings -Wno-main -Wno-unused-but-set-variable -Wno-unused-function -Wall")
# Option '-Wl,--no-merge-exidx-entries' removed as incompatible with clang.
set(LOCAL_CFLAGS "${LOCAL_CFLAGS} -funwind-tables")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${LOCAL_CFLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LOCAL_CFLAGS}")

set(CMAKE_C_FLAGS_DEBUG             "-O0 -g -D_DEBUG -DDEBUG")
set(CMAKE_C_FLAGS_RELEASE           "-O3 -g0 -flto -DNDEBUG")
set(CMAKE_C_FLAGS_RELWITHDEBINFO    "-O3 -g1 -flto -DNDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG           ${CMAKE_C_FLAGS_DEBUG})
set(CMAKE_CXX_FLAGS_RELEASE         ${CMAKE_C_FLAGS_RELEASE})
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO  ${CMAKE_C_FLAGS_RELWITHDEBINFO})

set(CRENGINE_SRC_FILES
    ${CR3_ROOT}/crengine/src/cp_stats.cpp
    ${CR3_ROOT}/crengine/src/lvstring.cpp
    ${CR3_ROOT}/crengine/src/lvstring8collection.cpp
    ${CR3_ROOT}/crengine/src/lvstring32collection.cpp
    ${CR3_ROOT}/crengine/src/lvstring32hashedcollection.cpp
    ${CR3_ROOT}/crengine/src/crlog.cpp
    ${CR3_ROOT}/crengine/src/serialbuf.cpp
    ${CR3_ROOT}/crengine/src/props.cpp
    ${CR3_ROOT}/crengine/src/lstridmap.cpp
    ${CR3_ROOT}/crengine/src/rtfimp.cpp
    ${CR3_ROOT}/crengine/src/lvmemman.cpp
    ${CR3_ROOT}/crengine/src/lvstyles.cpp
    ${CR3_ROOT}/crengine/src/crtxtenc.cpp
    ${CR3_ROOT}/crengine/src/lvtinydom.cpp
    ${CR3_ROOT}/crengine/src/chmfmt.cpp
    ${CR3_ROOT}/crengine/src/epubfmt.cpp
    ${CR3_ROOT}/crengine/src/pdbfmt.cpp
    ${CR3_ROOT}/crengine/src/wordfmt.cpp
    ${CR3_ROOT}/crengine/src/lvopc.cpp
    ${CR3_ROOT}/crengine/src/docxfmt.cpp
    ${CR3_ROOT}/crengine/src/fb3fmt.cpp
    ${CR3_ROOT}/crengine/src/odtfmt.cpp
    ${CR3_ROOT}/crengine/src/odxutil.cpp
    ${CR3_ROOT}/crengine/src/lvstsheet.cpp
    ${CR3_ROOT}/crengine/src/txtselector.cpp
    ${CR3_ROOT}/crengine/src/crtest.cpp
    ${CR3_ROOT}/crengine/src/lvbmpbuf.cpp
    ${CR3_ROOT}/crengine/src/hyphman.cpp
    ${CR3_ROOT}/crengine/src/crskin.cpp
    ${CR3_ROOT}/crengine/src/lvdocview.cpp
    ${CR3_ROOT}/crengine/src/lvpagesplitter.cpp
    ${CR3_ROOT}/crengine/src/lvtextfm.cpp
    ${CR3_ROOT}/crengine/src/lvrend.cpp
    ${CR3_ROOT}/crengine/src/wolutil.cpp
    ${CR3_ROOT}/crengine/src/crconcurrent.cpp
    ${CR3_ROOT}/crengine/src/mathml.cpp
    ${CR3_ROOT}/crengine/src/hist.cpp
    ${CR3_ROOT}/crengine/src/xxhash.c
    ${CR3_ROOT}/crengine/src/textlang.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvcacheableobject.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvimagesource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/crninepatchdecoder.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvjpegimagesource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvpngimagesource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvxpmimagesource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvgifimagesource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvgifframe.cpp
    ${CR3_ROOT}/crengine/src/lvimg/clzwdecoder.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvsvgimagesource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvstretchimgsource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvcolortransformimgsource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvalphatransformimgsource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvunpackedimgsource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvdrawbufimgsource.cpp
    ${CR3_ROOT}/crengine/src/lvimg/lvimg.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfnt.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvembeddedfont.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfont.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfntman.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfontglyphcache.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfontboldtransform.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfontcache.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfontdef.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfreetypeface.cpp
    ${CR3_ROOT}/crengine/src/lvfont/lvfreetypefontman.cpp
    ${CR3_ROOT}/crengine/src/lvdrawbuf/lvbasedrawbuf.cpp
    ${CR3_ROOT}/crengine/src/lvdrawbuf/lvgraydrawbuf.cpp
    ${CR3_ROOT}/crengine/src/lvdrawbuf/lvcolordrawbuf.cpp
    ${CR3_ROOT}/crengine/src/lvdrawbuf/lvinkmeasurementdrawbuf.cpp
    ${CR3_ROOT}/crengine/src/lvdrawbuf/lvimagescaleddrawcallback.cpp
    ${CR3_ROOT}/crengine/src/lvdrawbuf/lvdrawbuf_utils.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvdefstreambuffer.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvfilemappedstream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvnamedstream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvfilestream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvdirectorycontainer.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvcachedstream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvzipdecodestream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvziparc.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvrararc.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvmemorystream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvtcrstream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvblockwritestream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvstream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvbase64stream.cpp
    ${CR3_ROOT}/crengine/src/lvstream/lvstreamutils.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvfileparserbase.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvtextfilebase.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvtextparser.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvtextlinequeue.cpp
    ${CR3_ROOT}/crengine/src/lvxml/pmltextimport.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvtextrobustparser.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvtextbookmarkparser.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvxmlparser.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvhtmlparser.cpp
    ${CR3_ROOT}/crengine/src/lvxml/fb2coverpageparsercallback.cpp
    ${CR3_ROOT}/crengine/src/lvxml/lvxmlutils.cpp
    ${CR3_ROOT}/crengine/src/locale_data/fc-lang-data.c
    ${CR3_ROOT}/crengine/src/locale_data/crlocaledata.cpp
)
#    ${CR3_ROOT}/crengine/src/cri18n.cpp
#    ${CR3_ROOT}/crengine/src/crgui.cpp

set(COFFEECATCH_SRC_FILES
    ${CR3_ROOT}/android/jni/coffeecatch/coffeecatch.c
    ${CR3_ROOT}/android/jni/coffeecatch/coffeejni.c
)

set(JNI_SRC_FILES
    ${CR3_ROOT}/android/jni/cr3engine.cpp
    ${CR3_ROOT}/android/jni/cr3java.cpp
    ${CR3_ROOT}/android/jni/docview.cpp
)

set(LOCAL_SRC_FILES
    ${JNI_SRC_FILES}
    ${CRENGINE_SRC_FILES}
)

# Add coffeecatch only on supported architectures.
if("${ANDROID_ABI}" STREQUAL "armeabi-v7a" OR "${ANDROID_ABI}" STREQUAL "arm64-v8a" OR "${ANDROID_ABI}" STREQUAL "mips" OR "${ANDROID_ABI}" STREQUAL "x86")
    set(LOCAL_SRC_FILES ${LOCAL_SRC_FILES} ${COFFEECATCH_SRC_FILES})
endif("${ANDROID_ABI}" STREQUAL "armeabi-v7a" OR "${ANDROID_ABI}" STREQUAL "arm64-v8a" OR "${ANDROID_ABI}" STREQUAL "mips" OR "${ANDROID_ABI}" STREQUAL "x86")

# thirdparty libraries
add_subdirectory(thirdparty_libs)

# Creates and names a library, sets it as either STATIC
# or SHARED, and provides the relative paths to its source code.
# You can define multiple libraries, and CMake builds them for you.
# Gradle automatically packages shared libraries with your APK.

add_library( # Sets the name of the library.
             cr3engine-3-2-X

             # Sets the library as a shared library.
             SHARED

             # Provides a relative path to your source file(s).
             ${LOCAL_SRC_FILES} )

# Searches for a specified prebuilt library and stores the path as a
# variable. Because CMake includes system libraries in the search path by
# default, you only need to specify the name of the public NDK library
# you want to add. CMake verifies that the library exists before
# completing its build.

find_library( # Sets the name of the path variable.
              log-lib

              # Specifies the name of the NDK library that
              # you want CMake to locate.
              log )

# Specifies libraries CMake should link to your target library. You
# can link multiple libraries, such as libraries you define in this
# build script, prebuilt third-party libraries, or system libraries.

target_link_libraries( # Specifies the target library.
        cr3engine-3-2-X

        # thirdparty static libs
        local_png
        local_jpeg
        local_freetype
        local_harfbuzz
        local_chmlib
        local_antiword
        local_fribidi
        local_unibreak
        local_qimagescale
        local_zstd
        local_utf8proc

        # Links the target library to the log library
        # included in the NDK.
        ${log-lib}
        -lm -lz -ldl)

=== thirdparty_unman/antiword/CMakeLists.txt ===
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF (${CMAKE_BUILD_TYPE} STREQUAL Release)
    ADD_DEFINITIONS( -DNDEBUG=1 )
ELSE()
    ADD_DEFINITIONS( -DDEBUG=1 )
ENDIF(${CMAKE_BUILD_TYPE} STREQUAL Release)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

SET (ANTIWORD_SOURCES 
#    main_u.c 
    asc85enc.c blocklist.c chartrans.c datalist.c depot.c
    dib2eps.c doclist.c fail.c finddata.c findtext.c fontlist.c
    fonts.c fonts_u.c hdrftrlist.c imgexam.c 
#    imgtrans.c jpeg2eps.c
    listlist.c misc.c notes.c options.c out2window.c pdf.c
    pictlist.c 
#    png2eps.c 
    prop0.c prop2.c prop6.c prop8.c
    properties.c propmod.c rowlist.c sectlist.c stylelist.c stylesheet.c
    summary.c tabstop.c unix.c utf8.c word2text.c worddos.c
    wordlib.c wordmac.c wordole.c wordwin.c xmalloc.c
)                                                          

IF (DEFINED CR3_ANTIWORD_PATCH)
    ADD_DEFINITIONS( -DANTIWORD_EXTERNAL_IO=1 )
ELSE ()
SET (ANTIWORD_SOURCES ${ANTIWORD_SOURCES}
#Output routines are implemented in CR
    output.c 
    xml.c
    text.c 
    fmt_text.c 
    postscript.c 
)
ENDIF (DEFINED CR3_ANTIWORD_PATCH)

if (WIN32)
SET (ANTIWORD_SOURCES ${ANTIWORD_SOURCES}
)
endif(WIN32)

ADD_LIBRARY(antiword STATIC ${ANTIWORD_SOURCES})

=== thirdparty_unman/qimagescale/CMakeLists.txt ===
set(qimagescale_SOURCES
qimagescale.cpp
)

add_library(qimagescale STATIC ${qimagescale_SOURCES})

=== android/jni/coffeecatch/Makefile ===
###############################################################################
#
# "FastLZ" compression library
#
###############################################################################

CFILES = coffeecatch.c

all: gcc test

clean:
	rm -f *.o *.obj *.so* *.dll *.exe *.pdb *.exp *.lib sample

tar:
	rm -f coffeecatch.tgz
	tar cvfz coffeecatch.tgz coffeecatch.txt coffeecatch.c coffeecatch.h Makefile LICENSE README.md

gcc:
	gcc -c -fPIC -O3 -g3 -pthread \
		-W -Wall -Wextra -Werror -Wno-unused-function \
		-D_REENTRANT -D_GNU_SOURCE \
		$(CFILES)
	gcc -shared -fPIC -O3 -Wl,-O1 -Wl,--no-undefined \
		-rdynamic -shared -Wl,-soname=libcoffeecatch.so \
		coffeecatch.o -o libcoffeecatch.so \
		-ldl -lpthread

test:
	gcc -c -fPIC -O3 -g3 \
		-W -Wall -Wextra -Werror -Wno-unused-function \
		-D_REENTRANT \
		sample.c -o sample.o
	gcc -fPIC -O3 -Wl,-O1 \
		-lcoffeecatch -L. \
		sample.o -o sample

=== cr3qt/src/qtc-gdbmacros/Makefile ===
#############################################################################
# Makefile for building: libgdbmacros.so.1.0.0
# Generated by qmake (2.01a) (Qt 4.5.0) on: Thu Nov 5 17:51:04 2009
# Project:  gdbmacros.pro
# Template: lib
# Command: /usr/bin/qmake-qt4 -spec /usr/share/qt4/mkspecs/linux-g++ -unix CONFIG+=debug_and_release CONFIG+=debug -o Makefile gdbmacros.pro
#############################################################################

first: debug
install: debug-install
uninstall: debug-uninstall
MAKEFILE      = Makefile
QMAKE         = /usr/bin/qmake-qt4
DEL_FILE      = rm -f
CHK_DIR_EXISTS= test -d
MKDIR         = mkdir -p
COPY          = cp -f
COPY_FILE     = $(COPY)
COPY_DIR      = $(COPY) -r
INSTALL_FILE  = install -m 644 -p
INSTALL_PROGRAM = install -m 755 -p
INSTALL_DIR   = $(COPY_DIR)
DEL_FILE      = rm -f
SYMLINK       = ln -sf
DEL_DIR       = rmdir
MOVE          = mv -f
CHK_DIR_EXISTS= test -d
MKDIR         = mkdir -p
SUBTARGETS    =  \
		debug \
		release

debug: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug
debug-make_default: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug 
debug-make_first: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug first
debug-all: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug all
debug-clean: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug clean
debug-distclean: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug distclean
debug-install: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug install
debug-uninstall: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug uninstall
release: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release
release-make_default: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release 
release-make_first: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release first
release-all: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release all
release-clean: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release clean
release-distclean: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release distclean
release-install: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release install
release-uninstall: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release uninstall

Makefile: gdbmacros.pro  /usr/share/qt4/mkspecs/linux-g++/qmake.conf /usr/share/qt4/mkspecs/common/g++.conf \
		/usr/share/qt4/mkspecs/common/unix.conf \
		/usr/share/qt4/mkspecs/common/linux.conf \
		/usr/share/qt4/mkspecs/qconfig.pri \
		/usr/share/qt4/mkspecs/features/qt_functions.prf \
		/usr/share/qt4/mkspecs/features/qt_config.prf \
		/usr/share/qt4/mkspecs/features/exclusive_builds.prf \
		/usr/share/qt4/mkspecs/features/default_pre.prf \
		/usr/share/qt4/mkspecs/features/debug.prf \
		/usr/share/qt4/mkspecs/features/debug_and_release.prf \
		/usr/share/qt4/mkspecs/features/default_post.prf \
		/usr/share/qt4/mkspecs/features/shared.prf \
		/usr/share/qt4/mkspecs/features/dll.prf \
		/usr/share/qt4/mkspecs/features/warn_on.prf \
		/usr/share/qt4/mkspecs/features/qt.prf \
		/usr/share/qt4/mkspecs/features/unix/thread.prf \
		/usr/share/qt4/mkspecs/features/moc.prf \
		/usr/share/qt4/mkspecs/features/resources.prf \
		/usr/share/qt4/mkspecs/features/uic.prf \
		/usr/share/qt4/mkspecs/features/yacc.prf \
		/usr/share/qt4/mkspecs/features/lex.prf \
		/usr/lib/libQtGui.prl \
		/usr/lib/libQtCore.prl
	$(QMAKE) -spec /usr/share/qt4/mkspecs/linux-g++ -unix CONFIG+=debug_and_release CONFIG+=debug -o Makefile gdbmacros.pro
/usr/share/qt4/mkspecs/common/g++.conf:
/usr/share/qt4/mkspecs/common/unix.conf:
/usr/share/qt4/mkspecs/common/linux.conf:
/usr/share/qt4/mkspecs/qconfig.pri:
/usr/share/qt4/mkspecs/features/qt_functions.prf:
/usr/share/qt4/mkspecs/features/qt_config.prf:
/usr/share/qt4/mkspecs/features/exclusive_builds.prf:
/usr/share/qt4/mkspecs/features/default_pre.prf:
/usr/share/qt4/mkspecs/features/debug.prf:
/usr/share/qt4/mkspecs/features/debug_and_release.prf:
/usr/share/qt4/mkspecs/features/default_post.prf:
/usr/share/qt4/mkspecs/features/shared.prf:
/usr/share/qt4/mkspecs/features/dll.prf:
/usr/share/qt4/mkspecs/features/warn_on.prf:
/usr/share/qt4/mkspecs/features/qt.prf:
/usr/share/qt4/mkspecs/features/unix/thread.prf:
/usr/share/qt4/mkspecs/features/moc.prf:
/usr/share/qt4/mkspecs/features/resources.prf:
/usr/share/qt4/mkspecs/features/uic.prf:
/usr/share/qt4/mkspecs/features/yacc.prf:
/usr/share/qt4/mkspecs/features/lex.prf:
/usr/lib/libQtGui.prl:
/usr/lib/libQtCore.prl:
qmake: qmake_all FORCE
	@$(QMAKE) -spec /usr/share/qt4/mkspecs/linux-g++ -unix CONFIG+=debug_and_release CONFIG+=debug -o Makefile gdbmacros.pro

qmake_all: FORCE

make_default: debug-make_default release-make_default FORCE
make_first: debug-make_first release-make_first FORCE
all: debug-all release-all FORCE
clean: debug-clean release-clean FORCE
distclean: debug-distclean release-distclean FORCE
	-$(DEL_FILE) Makefile

debug-mocclean: $(MAKEFILE).Debug
	$(MAKE) -f $(MAKEFILE).Debug mocclean
release-mocclean: $(MAKEFILE).Release
	$(MAKE) -f $(MAKEFILE).Release mocclean
mocclean: debug-mocclean release-mocclean

debug-mocables: $(MAKEFILE).Debug
	$(MAKE) -f $(MAKEFILE).Debug mocables
release-mocables: $(MAKEFILE).Release
	$(MAKE) -f $(MAKEFILE).Release mocables
mocables: debug-mocables release-mocables
FORCE:

$(MAKEFILE).Debug: Makefile
$(MAKEFILE).Release: Makefile

=== crengine/Tools/Fb2Linux/CMakeLists.txt ===

if(UNIX)
    add_definitions(-DLINUX -D_LINUX)
else(UNIX)
	message(FATAL_ERROR "This program availavle only for Unix/Linux!")
endif(UNIX)

find_package(X11 REQUIRED)

include_directories(${X11_INCLUDE_DIR})

set(SRC_LIST
    fb2v.cpp
    ../../src/xutils.cpp
)

file(COPY fb2.css DESTINATION ${CMAKE_CURRENT_BINARY_DIR} USE_SOURCE_PERMISSIONS)
file(COPY example.fb2 DESTINATION ${CMAKE_CURRENT_BINARY_DIR} USE_SOURCE_PERMISSIONS)
file(COPY "${CMAKE_SOURCE_DIR}/cr3gui/data/hyph/Russian_EnUS.pattern" DESTINATION ${CMAKE_CURRENT_BINARY_DIR} USE_SOURCE_PERMISSIONS)

add_executable(fb2view ${SRC_LIST})
target_link_libraries(fb2view crengine ${STD_LIBS} ${X11_LIBRARIES})

=== crengine/Tools/langstat/CMakeLists.txt ===

set(SRC_LIST
    langstat.cpp
)

set(crengine_part_SRC_LIST
    ../../src/cp_stats.cpp
    ../../src/crtxtenc.cpp
    ../../src/lvmemman.cpp
    ../../src/lvstream/lvdefstreambuffer.cpp
    ../../src/lvstream/lvfilemappedstream.cpp
    ../../src/lvstream/lvnamedstream.cpp
    ../../src/lvstream/lvfilestream.cpp
    ../../src/lvstream/lvstream.cpp
    ../../src/lvstream/lvziparc.cpp
    ../../src/lvstream/lvzipdecodestream.cpp
    ../../src/lvstream/lvmemorystream.cpp
    ../../src/lvstream/lvcachedstream.cpp
    ../../src/lvstream/lvtcrstream.cpp
    ../../src/lvstream/lvdirectorycontainer.cpp
    ../../src/lvstream/lvblockwritestream.cpp
    ../../src/lvstream/lvstreamutils.cpp
    ../../src/lvstring.cpp
    ../../src/crlog.cpp
    ../../src/serialbuf.cpp
)

add_definitions(-DBUILD_LITE=1)

if(WIN32)
    add_definitions(-DWIN32 -D_CONSOLE)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mconsole")
endif(WIN32)

add_executable(langstat ${SRC_LIST} ${crengine_part_SRC_LIST})
target_link_libraries(langstat ${STD_LIBS})

=== crengine/Tools/wtf8-test/CMakeLists.txt ===

set(SRC_LIST
    main.cpp
)

set(crengine_part_SRC_LIST
    ../../src/cp_stats.cpp
    ../../src/crtxtenc.cpp
    ../../src/lvmemman.cpp
    ../../src/lvstream/lvdefstreambuffer.cpp
    ../../src/lvstream/lvfilemappedstream.cpp
    ../../src/lvstream/lvnamedstream.cpp
    ../../src/lvstream/lvfilestream.cpp
    ../../src/lvstream/lvstream.cpp
    ../../src/lvstream/lvziparc.cpp
    ../../src/lvstream/lvzipdecodestream.cpp
    ../../src/lvstream/lvmemorystream.cpp
    ../../src/lvstream/lvcachedstream.cpp
    ../../src/lvstream/lvtcrstream.cpp
    ../../src/lvstream/lvdirectorycontainer.cpp
    ../../src/lvstream/lvblockwritestream.cpp
    ../../src/lvstream/lvstreamutils.cpp
    ../../src/lvstring.cpp
    ../../src/crlog.cpp
    ../../src/serialbuf.cpp
)

#add_definitions(-DBUILD_LITE=1)

if(UNIX)
    add_definitions(-DLINUX -D_LINUX)
endif(UNIX)

if(WIN32)
    add_definitions(-DWIN32 -D_CONSOLE)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mconsole")
endif(WIN32)

add_executable(wtf8-test ${SRC_LIST} ${crengine_part_SRC_LIST})
target_link_libraries(wtf8-test ${STD_LIBS})

=== android/app/thirdparty_libs/fribidi/CMakeLists.txt ===
project(local_fribidi C)

cmake_minimum_required(VERSION 3.4)

set(FRIBIDI_SOURCE_DIR "${PROJECT_SOURCE_DIR}/../../../../thirdparty/${REPO_FRIBIDI_SRCDIR}")
set(FRIBIDI_CONFIG_DIR "${PROJECT_SOURCE_DIR}")

include_directories(${FRIBIDI_SOURCE_DIR})
include_directories(${FRIBIDI_CONFIG_DIR})
include_directories(${FRIBIDI_CONFIG_DIR}/lib)
add_definitions(-DHAVE_CONFIG_H=1)

set(FRIBIDI_SOURCE
		${FRIBIDI_SOURCE_DIR}/lib/fribidi.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-arabic.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-bidi.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-bidi-types.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-char-sets.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-char-sets-cap-rtl.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-char-sets-cp1255.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-char-sets-cp1256.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-char-sets-iso8859-6.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-char-sets-iso8859-8.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-char-sets-utf8.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-deprecated.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-joining.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-joining-types.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-mirroring.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-brackets.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-run.c
		${FRIBIDI_SOURCE_DIR}/lib/fribidi-shape.c
)

add_library(local_fribidi STATIC ${FRIBIDI_SOURCE})

=== PKGBUILD ===
# Maintainer: Balló György <ballogyor+arch at gmail dot com>
# Contributor: Ivan Naumeiko <Ivan.Naumeiko  AT gmail DOT com>

pkgname=coolreader
pkgver=3.2.59
pkgrel=8
pkgdesc='Fast and small XML/CSS based eBook reader'
arch=('x86_64')
url='https://github.com/buggins/coolreader'
license=('GPL2')
depends=('fribidi' 'hicolor-icon-theme' 'libunibreak' 'qt5-base')
makedepends=('cmake' 'ninja' 'qt5-tools')
source=("https://github.com/buggins/coolreader/archive/cr$pkgver/$pkgname-$pkgver.tar.gz"
        'cr3.appdata.xml')
sha256sums=('54253ce3da8f3575d7e64f0afd3d2e9d369ca4e785584cfad4462eead1b8f51e'
            '9d868cfd61b686b5a398797819367f16d7a65f1f5420441fb34c8d39236f7382')

prepare() {
  sed -i 's|src/desktop/cr3.png DESTINATION share/pixmaps|src/desktop/cr3.png DESTINATION share/icons/hicolor/32x32/apps|
          s|src/desktop/cr3.xpm DESTINATION share/pixmaps|src/icons/cr3.png DESTINATION share/icons/hicolor/48x48/apps|' $pkgname-cr$pkgver/cr3qt/CMakeLists.txt
}

build() {
  cmake -S $pkgname-cr$pkgver -B build -G Ninja \
    -DCMAKE_INSTALL_PREFIX='/usr' \
    -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
    -DGUI=QT5 \
    -DMAX_IMAGE_SCALE_MUL=2 \
    -DDOC_DATA_COMPRESSION_LEVEL=3 \
    -DDOC_BUFFER_SIZE=0x140000
  cmake --build build
}

package() {
  DESTDIR="$pkgdir" cmake --install build
  install -Dm644 cr3.appdata.xml "$pkgdir/usr/share/metainfo/cr3.appdata.xml"
}

=== packages/openinkpot/debian/control ===
Source: cr3
Section: gui
Maintainer: Alexander Kerner <lunohod@openinkpot.org>
Build-Depends: debhelper (>= 5.0.22), cdbs, libxcb1-dev, libxcb-atom1-dev, libxcb-image0-dev, libxcb-aux0-dev, libxcb-randr0-dev, libxcb-keysyms1-dev, libz-dev, libjpeg62-dev, libpng12-dev, libtinydict-dev, autoconf, libtool, automake, pkg-config, libfreetype6-dev, libfontconfig1-dev
XCS-Cross-Host-Build-Depends: debhelper (>> 2.0.0), cdbs, cdbs-embedded, cmake, pkg-config
XCS-Cross-Build-Depends: libz1-dev, libjpeg62-dev, libpng12-dev, libfreetype6-dev, libfontconfig1-dev, libxcb1-dev, libxcb-image0-dev, libxcb-aux0-dev, libxcb-randr0-dev, libxcb-atom1-dev, libxcb-keysyms1-dev
Priority: optional
Standards-Version: 3.6.2

Package: cr3
Architecture: any
Depends: ${shlibs:Depends}, cr3-settings
Description: e-book reader
 CoolReader3 is an e-book reader.
 .
 Main features:
  * supports several open e-book formats: fb2, html, epub, rtf,
    tcr (psion text), plain text
  * reads directly from zip archives
  * automatically determines encodings
  * automatically generates a table of contents
  * keeps the last open book and the last read positions for all open books
    between runs
  * automatic hyphenation (patterns for several languages are included)
 .
  Homepage: http://www.coolreader.org/

Package: cr3-settings-v3
Architecture: all
Depends: cr3
Provides: cr3-settings
Conflicts: cr3-settings
Replaces: cr3-settings
Description: V3 specific settings
 This package provides V3 specific settings.

Package: cr3-settings-n516
Architecture: all
Depends: cr3
Provides: cr3-settings
Conflicts: cr3-settings
Replaces: cr3-settings
Description: N516 specific settings
 This package provides N516 specific settings.
